package com.simplecleaner.app.ui.splash

import android.Manifest
import android.annotation.SuppressLint
import android.content.Intent
import android.os.Build
import android.os.Bundle
import android.text.SpannableString
import android.text.Spanned
import android.text.method.LinkMovementMethod
import android.text.style.ClickableSpan
import android.text.style.UnderlineSpan
import android.util.Log
import android.view.View
import androidx.activity.viewModels
import androidx.core.graphics.toColorInt
import androidx.core.net.toUri
import androidx.core.view.ViewCompat
import androidx.core.view.WindowInsetsCompat
import androidx.lifecycle.lifecycleScope
import com.simplecleaner.app.GlobalConfig.URL_PRIVACY
import com.simplecleaner.app.MyApplication
import com.simplecleaner.app.R
import com.simplecleaner.app.SpConstObject.ifAgreePrivacy
import com.simplecleaner.app.SpConstObject.isGuided
import com.simplecleaner.app.base.BaseActivity
import com.simplecleaner.app.base.jumpAction
import com.simplecleaner.app.bean.FeatureBean.Companion.BATTERY_INFO
import com.simplecleaner.app.bean.config.AdConfigBean
import com.simplecleaner.app.bean.config.ConfigBean
import com.simplecleaner.app.business.ads.AdsMgr
import com.simplecleaner.app.business.ads.AdsShowCallBack
import com.simplecleaner.app.business.helper.EventUtils
import com.simplecleaner.app.business.helper.NewComUtils
import com.simplecleaner.app.business.helper.NewComUtils.spConfig
import com.simplecleaner.app.business.service.StayJobService.Companion.startStayJobService
import com.simplecleaner.app.databinding.ActivitySplashBinding
import com.simplecleaner.app.ui.dialog.StoragePermissionDialog
import com.simplecleaner.app.ui.guide.GuideCleanActivity
import com.simplecleaner.app.ui.guide.GuideExperienceActivity
import com.simplecleaner.app.ui.main.MainActivity
import com.simplecleaner.app.utils.LogEx
import com.simplecleaner.app.utils.PermissionUtils.checkStorePermission
import com.simplecleaner.app.utils.PermissionUtils.requestStoragePermission
import com.simplecleaner.app.utils.UmpUtils
import com.simplecleaner.app.utils.umpCalled
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.launch
import java.util.concurrent.atomic.AtomicBoolean


@SuppressLint("CustomSplashScreen")
class SplashActivity : BaseActivity<ActivitySplashBinding>(ActivitySplashBinding::inflate) {

    private val viewModel: SplashViewModel by viewModels()

    override fun onWindowFocusChanged(hasFocus: Boolean) {
        super.onWindowFocusChanged(hasFocus)
    }

    override fun useDefaultImmersive() {
        ViewCompat.setOnApplyWindowInsetsListener(binding.root) { v, insets ->
            val systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars())
            v.setPadding(systemBars.left, 0, systemBars.right, systemBars.bottom)
            insets
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
//        initUMP()
        super.onCreate(savedInstanceState)
        handleIntentExtras()
    }

    override fun onResumeOneShoot() {
        super.onResumeOneShoot()
        viewModel.startCountdown()
    }

    override fun onStop() {
        super.onStop()
        viewModel.stopCountdown()
    }

    override fun initView() {
        super.initView()
        showLoadingAd()
        setPrivacyPolicy()
        if (!isGuided) {
            requestNotificationPermission()
        }
        viewModel.jumpNext = {
            Log.e(TAG, "Countdown jumpNext")
            jumpNext()
        }
        viewModel.onTick = { s, t, p ->
//            Log.e(TAG, "onTick $s $t")
            binding.progressBar.setProgress(p.toDouble())
        }
    }

    private fun setPrivacyPolicy() {

        val spannableString = SpannableString(getString(R.string.privacy_policy))
        spannableString.setSpan(UnderlineSpan(), 0, spannableString.length, Spanned.SPAN_INCLUSIVE_INCLUSIVE)
        spannableString.setSpan(object : ClickableSpan() {
            override fun onClick(widget: View) {
                startActivity(Intent(Intent.ACTION_VIEW, URL_PRIVACY.toUri()))
            }
        }, 0, spannableString.length, Spanned.SPAN_INCLUSIVE_INCLUSIVE)

        binding.tvPrivacy.text = spannableString
        binding.tvPrivacy.movementMethod = LinkMovementMethod.getInstance()
        binding.tvPrivacy.setLinkTextColor("#F2FEF8".toColorInt())

//        val spannableString2 = SpannableString("terms of service")
//        spannableString2.setSpan(UnderlineSpan(), 0, spannableString2.length, Spanned.SPAN_INCLUSIVE_INCLUSIVE)
//        spannableString2.setSpan(object : ClickableSpan() {
//            override fun onClick(widget: View) {
//                startActivity(Intent(Intent.ACTION_VIEW, URL_USE.toUri()))
//            }
//        }, 0, spannableString2.length, Spanned.SPAN_INCLUSIVE_INCLUSIVE)
//
//        binding.tvTerms.text = spannableString2
//        binding.tvTerms.movementMethod = LinkMovementMethod.getInstance()
//        binding.tvTerms.setLinkTextColor("#2DD29E".toColorInt())

    }

    private fun requestNotificationPermission() {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
            val array = arrayOf(Manifest.permission.POST_NOTIFICATIONS)
            launcher.launch(array) { permissions ->
                val flag = permissions.values.all { it }
                if (flag) MyApplication.appContext.startStayJobService()
            }
        }
    }

    override fun initListener() {
        super.initListener()
        binding.tvStart.setOnClickListener {
            ifAgreePrivacy = true
            showLoadingAd()
            EventUtils.event("app_start")
            EventUtils.event("page_${javaClass.simpleName}")
            viewModel.startCountdown()
            MyApplication.appContext.initApp()
        }
    }

    override fun handleBackCallBack() {

    }

    private fun initUMP(callBack: () -> Unit) {

        if (AdConfigBean.adsConfigBean.requestUmp && !umpCalled) {
            umpCalled = true

            val ump = UmpUtils(this)
            if (ump.consentInformation.canRequestAds()) {
                callBack.invoke()
            } else {
                ump.callback = {
                    callBack.invoke()
                }
                LogEx.logDebug(TAG, "requestUMP")
                ump.requestUMP()
            }

        } else {
            callBack.invoke()
        }


    }

    private fun showLoadingAd() {
        binding.clBottomStart.visibility = if (ifAgreePrivacy) View.GONE else View.VISIBLE
        binding.clBottomLoading.visibility = if (ifAgreePrivacy) View.VISIBLE else View.GONE
        binding.llConsent.visibility = if (ifAgreePrivacy) View.GONE else View.VISIBLE

        if (ifAgreePrivacy) {

            val acAction = {
                initUMP {
                    LogEx.logDebug(TAG, "initUMP callback")

                    AdsMgr.showOpen(this, showCallBack = object : AdsShowCallBack() {
                        override fun show() {
                            super.show()
                            viewModel.stopCountdown()
                            binding.progressBar.setProgress(100.0)
                        }

                        override fun next() {
                            val action = {
                                LogEx.logDebug(TAG, "next")
                                viewModel.overCountDown()
                                binding.progressBar.setProgress(100.0)
                                binding.root.postDelayed({ jumpNext() }, 250)
                            }
                            LogEx.logDebug("AdmobEvent", "inter adShowed=${adShowed}")
                            if (adShowed) {
                                action.invoke()
                            } else {
                                LogEx.logDebug("AdmobEvent", "inter open show inter")
                                AdsMgr.showInsert(this@SplashActivity, showCallBack = object : AdsShowCallBack() {
                                    override fun next() {
                                        action.invoke()
                                    }
                                })
                            }

                        }

                    })
                }
            }

            if (spConfig.isNotEmpty()) {
                Log.e(TAG, "1")
                acAction.invoke()
            } else {
                if (NewComUtils.requestCfgIng.get()) {
                    Log.e(TAG, "requestCfg")
                    NewComUtils.requestCfgCallBackMap.put("adCallBack") {
                        Log.e(TAG, "requestCfgCallBack")
                        lifecycleScope.launch(Dispatchers.Main) {
                            Log.e(TAG, "2")
                            acAction.invoke()
                        }
                    }
                } else {
                    Log.e(TAG, "3")
                    acAction.invoke()
                }
            }
        }
    }

    val jumped = AtomicBoolean(false)
    fun jumpNext() {
        if (jumped.get()) return
        jumped.set(true)

        when {
            !isGuided -> {
                isGuided = true
                when (ConfigBean.configBean.guideMode) {
                    0 -> {
                        goToAc(GuideExperienceActivity::class.java)
                    }

                    1 -> {
                        goToAc(GuideCleanActivity::class.java)
                    }

                    else -> goToAc(MainActivity::class.java)
                }
                finish()
            }

            isHotLaunch -> {
                goToAc(MainActivity::class.java)
                finish()
            }

            actionId.isNotEmpty() -> {
                actionIdJump()
            }

            else -> {
                goToAc(MainActivity::class.java)
                finish()
            }
        }
        intent.extras?.clear()
    }

    fun actionIdJump() {
        when (actionId) {
            BATTERY_INFO -> {
                jumpAction(actionId)
                finish()
            }

            else -> {

                val actionStorage = {
                    if (checkStorePermission()) {
                        jumpAction(actionId)
                        finish()
                    } else {
                        val dialog = StoragePermissionDialog(this)
                        dialog.action = {
                            requestStoragePermission(launcher) {
                                if (it) {
                                    jumpAction(actionId)
                                    finish()
                                } else {
                                    goToAc(MainActivity::class.java)
                                    finish()
                                }
                            }
                        }
                        dialog.showDialog()
                    }
                }

                actionStorage.invoke()

            }

        }
    }

    override fun onNewIntent(intent: Intent?) {
        super.onNewIntent(intent)
        handleIntentExtras()
    }

    var isHotLaunch: Boolean = false
    var actionId = ""
    fun handleIntentExtras() {
        super.onNewIntent(intent)
        actionId = intent?.extras?.getString("actionId") ?: ""
        isHotLaunch = intent?.extras?.getBoolean("isHotLaunch") == true
    }

}